import socket
import xml.etree.ElementTree as ET
from xml.etree.ElementTree import Element, SubElement
from time import sleep #time.sleep() relace to sleep()
import decimal
import math

# Could have used only one DURATION constant but chose two. This gives play options.

durationFwd = 5000 # This is the duration of the motor spinning. used for forward direction

durationBwd = 5000 # This is the duration of the motor spinning. used for reverse direction

#print('Duration Fwd set to ' + str(durationFwd))

#print('Duration Bwd set to ' + str(durationBwd))

#

delay = 0.0001 # 0.000001 This is actualy a delay between PUL pulses - effectively sets the mtor rotation speed. (lower delay will make fast rotate but higher delay will make slow rotate)

print('Speed set to ' + str(delay))

#

#cycles = 1000 # This is the number of cycles to be run once program is started.

#cyclecount = 0 # This is the iteration of cycles to be run once program is started.

#print('number of Cycles to Run set to ' + str(cycles))

#

#

new_data = 10

current_data = 0

previous_data = 0



cal_Fwd = 0

cal_Bwd = 0



reset_data1 = -10

reset_data2 = -100



int_data = 0

test = 0

x = 0

host = '172.31.1.10'
port = 59152

def float_range(start, stop, step):

  while start < stop:

    yield float(start)

    start += decimal.Decimal(step)

def forward():

    cal_Fwd = (47.068*(current_data))+37.88

    print("cal_Fwd = %f"%(cal_Fwd))

    durationFwd = math.ceil(cal_Fwd)

    print(durationFwd)
    #x = 0
    #while x < durationFwd:
    #for x in range(durationFwd):

        #x = x + 1
        #sleep(delay)



        #sleep(delay)

        #print('x=%f'%(x))






    #sleep(.5)  # pause for possible change direction
    return


def reverse():










    cal_Bwd = (47.068 * (current_data)) + 37.88

    print("cal_Bwd = %f" % (cal_Bwd))

    durationBwd = math.ceil(cal_Bwd)

    print(durationBwd)
    #x=0
    #while x < durationBwd:
    #for x in range(durationBwd):

        #durationBwd = durationBwd+1
        #sleep(delay)



        #sleep(delay)

        #print('d')





    #sleep(.5)  # pause for possible change direction

    return

def DataTransfer():
    # TRANSFERRED_DATA TEMPLATE
    '''
    <Sensor>
    <Message>Example message</Message>
    <Positions>
        <Current X="4645.2" />
        <Before>
        <X>0.9842</X>
        </Before>
    </Positions>
    <Nmb>8</Nmb>
    <Status>
        <IsActive>1</IsActive>
    </Status>
    <Read>
        <xyzabc X="210.3" Y="825.3" Z="234.3" A="84.2" B="12.3" C="43.5" />
    </Read>
    <Show error="0" temp="9929">Taginfo in attributes</Show>
    <Free>2912</Free>
    </Sensor>
    '''
    # Main Node
    external = Element('External')
    # Node Status Define
    status = SubElement(external, 'Status')
    mode = SubElement(status, 'Mode')
    liveActive = SubElement(status, 'LiveActive')
    errorActive = SubElement(status, 'ErrorActive')
    programNumber = SubElement(status, 'ProgramNumber')
    taskEnable = SubElement(status, 'TaskEnable')
    message = SubElement(status, 'Message')
    # Node : Status Initialize
    mode.text = 'AUT'
    liveActive.text = '1'
    errorActive.text = '0'
    programNumber.text = '0'
    taskEnable.text = '0'
    message.text = 'External Node is Initilized'

    # Node : PoseRequest Define/Initailize
    poseRequest = SubElement(external, 'PoseRequest',
                             X='100.101', Y='200.002', Z='300.003',
                             A='10.1', B='20.2', C='30.3')

    # Node : Extruder Define
    extruder = SubElement(external, "Extruder")
    filamentFeed = SubElement(extruder, "FilamentFeed")
    filamentExtrusion = SubElement(extruder, "FilamentExtrusion")
    # Node : Extruder Initialize
    filamentFeed.text = '0.0'
    filamentExtrusion.text = '0.0'

    # Node : HeatCartridge Define
    heatCartridge = SubElement(external, "HeatCartridge")
    temperatureC = SubElement(heatCartridge, "TemperatureC")
    # Node : HeatCartridge Initialize
    temperatureC.text = '0'

    # Transferred Data Creation
    transferData = open('TransferData.xml', 'w')
    transferData.write('<?xml version="1.0"?>')
    transferData.write(ET.tostring(external).decode('utf-8'))
    transferData.close()

    # TRANSFERRED_DATA TEMPLATE
    '''
    <Robot>
        <Status>
            <Mode></Mode>
            <LiveActive>0</LiveActive>
            <ErrorActive>0</ErrorActive>
            <ProgramNumber>0</ProgramNumber>
            <TaskEnable>0</TaskEnable>
            <Message></Message>
        </Status>
        <PoseCurrent X="85.067657" Y="5.151343" Z="20.812719" A="4.355326" B="-1.605621" C="0.000000" E1="0.000000" E2="0.000000" E3="0.000000" E4="0.000000" E5="" E6="">
        </PoseCurrent>
        <Information>
            <Data1>0.000000</Data1>
            <Data2>0.000000</Data2>
            <Data3>0.000000</Data3>
            <Data4>0.000000</Data4>
        </Information>
    </Robot>
    '''


def ReceiveData(data):
    receivedData = open('ReceivedData.xml', 'w')
    receivedData.write('<?xml version="1.0"?>')
    receivedData.write(data)
    receivedData.close()


if __name__ == '__main__':
    while True:
        # Program Initialize
        command = ''
        DataTransfer()  # >>> TransferData.xml
        with open('TransferData.xml', 'r') as f:
            command = command + f.read()
        command = command.encode()

        # Port, Socket Initialize
        sever = socket.socket()
        sever.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)  # Reused Port
        # server = socket.socket(socket.AF_INET,  socket.SOCK_STREAM)
        sever.bind((host, port))
        sever.listen(1)
        print('Waitting for client')

        client, addr = sever.accept()
        data = client.recv(1024).decode('utf-8')

        client.send(command)
        ReceiveData(data)  # >>> #ReceivedData.xml

        root = ET.parse('ReceivedData.xml').getroot()
        print('Connected from ', str(addr))

        rdata = root[1].attrib['E1']

        print(rdata)
        int_data = float(rdata)

        test = int_data + 2
        print("test = %f" % (test))
        new_data = int_data
        print("new_data  = %f" % (new_data))

        current_data = new_data - previous_data
        # print(list(float_range(0, 1, '0.1')))
        print("previous_data = %f" % (previous_data))
        print("current_data = %f" % (current_data))

        if (current_data < reset_data1):
            current_data = new_data
            forward()
            previous_data = current_data
            print("a")
            client.close
        elif (new_data > previous_data):
            current_data = +(current_data)
            forward()
            previous_data = current_data
            print("b")
            client.close
        elif (new_data < previous_data):
            current_data = -(current_data)
            reverse()
            previous_data = current_data
            print("c")  ### may be disable it have some error and may be use try...error or run server before client
            client.close
        else:
            print("f")
            client.close
            ##########Close######
        client.close
            ####################


            # client.close

        print('Connection Endded')
